
// Die Variablen sind global und werden von mehreren Funktionen in diesem Tab verwendet und verändert
double winkelNow = 0.0; // atan2 der aktuellen Position
double winkelZiel = 0.0; // atan2 vom Zielpunkt
double winkelDrehen = 0.0; // Soweit muss der Roboter drehen 
float xNow = 0.0; //X-Koordinate der aktuellen Position
float yNow = 0.0; //Y-Koordinate der aktuellen Position
float xZiel = 0.0; //X-Koordinate des Ziels
float yZiel = 0.0; //Y-Koordinate des Ziels
float strecke = 0.0; // Diese Strecke muss der Roboter zurücklegen
float xDifferenz =0.0; //X-Streckendifferenz zwischen Standort und Ziel
float yDifferenz= 0.0; //Y-Streckendifferenz zwischen Standort und Ziel

//Berechnet die zurückzulegende Strecke, Ausgabe in Längeneinheiten
void streckeBerechnen() {
  xDifferenz= xZiel-xNow;
  yDifferenz= yZiel-yNow;
  strecke = sqrt( square(yDifferenz) + square(xDifferenz)); // Satz des Phytagoras
}

//Berechnet den zudrehenden Winkel, Ausgabe im Bogenmaß und gegen den Uhrzeigersinn
void drehwinkel() {
  winkelZiel= atan2(xDifferenz,yDifferenz); // Berechnet aus einem Vektor
  winkelDrehen= winkelZiel-winkelNow;
}

//Aktualisiert die Positionsdaten
void neuerOrt() {
  xNow=xZiel;
  yNow=yZiel;
  winkelNow= winkelZiel;
}

// Der Roboter fährt eine in Längeneinheiten angegebene Strecke 
void geradeaus(float a)
{
  int steps= 50*a; //Der Faktor bestimmt die Länge einer Längeneinheit

  for(int i=0; i<steps; i++)
  {
  motor1.move(1);
  motor2.move(1);
  }
  
}

// Der Roboter dreht sich einen im Bogenmaß angegebenen Winkel
void drehen(double grad){

   // Schritte pro Umdrehung (360°)pro Rad = 490
   //Umrechnung von Bogenmaß in Schritte pro Rad
   if(grad>3.14) grad= grad - 2*3.14;
   grad = abs(grad);
   int schritte = grad*77.985; //77.985 = 490/2PI 

  // Wahl der Drehrichtung über den kleineren Winkel
  if (grad>=0) {
    for(int i=0; i<schritte; i++) {
      motor1.move(1);
      delay(3); // Verringert Ungenauigkeiten durch zu schnelle Bewegung
      motor2.move(-1);
      delay(3);
    }
  } else {
    for(int i=0; i<schritte; i++) {
      motor1.move(-1);
      delay(3);  
      motor2.move(1);
      delay(3);
    }
  }
}


// Der Roboter fährt zu einem Zielpunkt und aktualisiert seine Positionsdaten
void zuKoordinateBewegen(float x, float y) {
  xZiel=x;
  yZiel=y;
  streckeBerechnen();
  drehwinkel();
  drehen(winkelDrehen); 
  geradeaus(strecke); 
  neuerOrt();
   
}

